//* Fri Jan 20 01:00:02 JST 2012 Naoyuki Sawa
//- P/ECEカーネルのpceFontPrintf()のバグ修正対策です。
//  詳細は、P/ECE研究記録「pceFontPrintf()のバグ」を参照してください。
//	http://www.piece-me.org/piece-lab/piece-lab-2012.txt
//  ただし、上記記事で提示したdoprnt.cの変更点と、少し違いがあります。
//- 一点目:
//  上記記事ではPUTC()をマクロのまま{…}で囲って修正しましたが、以下のコードではPUTC()を関数化しました。
//  関数化する方が、コードサイズが小さくなるからです。
//  PUTC()をマクロのまま修正するとdoprnt.oは3KB弱ですが、PUTC()を関数化すると2KB弱で済みます。
//- 二点目:
//  doprnt()をstatic関数にしました。
//  clipprnt.cの中でも別のdoprnt()を実装しているため、万一の事故を防ぐためです。
//  clipprnt.cのdoprnt()は既にstatic関数ですから、こちらがグローバル関数でも衝突することは無いのですが、
//  両方ともstatic関数とする方が確実に安全だからです。
//- 三点目:
//  元のdoprnt.cで、#ifブロックで無効化されている部分や、無意味な部分に、//del//をマークしました。
//  元のままでもコンパイル対象外ですから、生成されるコードには違いは無いのですが、わかり易さのためです。
//  また、追加した部分もわかり易いように、//add//をマークしました。

//del//#if 0
//del//#if defined(LIBC_SCCS) && !defined(lint)
//del//static char sccsid[] = "@(#)doprnt.c	5.39 (Berkeley) 6/28/90";
//del//#endif /* LIBC_SCCS and not lint */
//del//
//del//#define _doprnt ____doprnt
//del//#include    <stdio.h>
//del//#include    <smcvals.h>
//del//#include    <stdarg.h>
//del//#include    <string.h>
//del//#include    <math.h>
//del//#include    <ctype.h>
//del//#include    <errno.h>
//del//#undef _doprnt
//del//#endif

typedef unsigned char u_char;
typedef unsigned long u_long;
//del//#if 0
//del//#include <varargs.h>
//del//#include <locale.h>
//del//#else
#include <smcvals.h>
#include <stdarg.h>
//del//#endif
#include <ctype.h>

//del//#if 0
//del///* 11-bit exponent (VAX G floating point) is 308 decimal digits */
//del//#define	MAXEXP		308
//del///* 128 bit fraction takes up 39 decimal digits; max reasonable precision */
//del//#define	MAXFRACT	39
//del//
//del//#define	DEFPREC		6
//del//#define	DEFLPREC	14
//del//
//del//#define	BUF		(MAXEXP+MAXFRACT+1)	/* + decimal point */
//del//#else
#define	BUF		(40+1)	/* + decimal point */
//del//#endif


#define ARG(basetype) \
	_ulong = flags&LONGINT ? va_arg(argp, long basetype) : \
	    flags&SHORTINT ? (short basetype)va_arg(argp, int) : \
	    va_arg(argp, int)

//del///* static int nan = 0; */

// 高速処理のためインチキする
#define isascii(a) (1)
#define isdigit(a) ((a)>='0' && (a)<='9')

//del//#if 0
//del//static char decimal = '.';
//del//#endif

//del///* have to deal with the negative buffer count kludge */
//del//#define	NEGATIVE_COUNT_KLUDGE

#define	LONGINT		0x01		/* long integer */
#define	LONGDBL		0x02		/* long double; unimplemented */
#define	SHORTINT	0x04		/* short integer */
#define	ALT		0x08		/* alternate form */
#define	LADJUST		0x10		/* left adjustment */
#define	ZEROPAD		0x20		/* zero (as opposed to blank) pad */
#define	HEXPREFIX	0x40		/* add 0x or 0X prefix */


//del//#if 1
#define	todigit(c)	((c) - '0')
//del//#else
//del//static int todigit(char c)
//del//{
//del//  if (c<='0') return 0;
//del//  if (c>='9') return 9;
//del//  return c-'0';
//del//}
//del//#endif

typedef struct tagOUTBF {
	char *outp;
	char *topp;
	char *endp;
	void (*flush)( struct tagOUTBF *pob );
} OUTBF;

//del//#define PUTC(ch) *pob->outp++ = (ch); if (pob->outp >= pob->endp) pob->flush(pob);
#define PUTC(ch) _PUTC((pob), (ch))                                                                     //add//
static void _PUTC(OUTBF* pob, int ch) { *pob->outp++ = ch; if(pob->outp >= pob->endp) pob->flush(pob); }//add//


static//add//
int doprnt( OUTBF *pob, const char *fmt0, va_list argp )
{
	u_char *fmt;		/* format string */
	int ch;			/* character from fmt */
	int cnt;		/* return value accumulator */
	int n;			/* random handy integer */
	char *t;		/* buffer pointer */
//del//#if 0
//del//	double _double;		/* double precision arguments %[eEfgG] */
//del//	char softsign;		/* temporary negative sign for floats */
//del//#endif
	u_long _ulong;		/* integer arguments %[diouxX] */
	int base;		/* base for [diouxX] conversion */
	int dprec;		/* decimal precision in [diouxX] */
	int fieldsz;		/* field size expanded by sign, etc */
	int flags;		/* flags as above */
	int fpprec;		/* `extra' floating precision in [eEfgG] */
	int prec;		/* precision from format (%.3d), or -1 */
	int realsz;		/* field size expanded by decimal precision */
	int size;		/* size of converted field or string */
	int width;		/* width from format (%8d), or 0 */
	char sign;		/* sign prefix (' ', '+', '-', or \0) */
	char *digs;		/* digits for [diouxX] conversion */
	char buf[BUF];		/* space for %c, %[diouxX], %[eEfgG] */
//del//#if 0
//del//	decimal = localeconv()->decimal_point[0];
//del//#endif
	fmt = (u_char *)fmt0;
	digs = "0123456789abcdef";
	for (cnt = 0;; ++fmt) {

		while ( (ch = *fmt) && ch != '%' ) {
			PUTC( ch );
			fmt++;
			cnt++;
		}

		if ( !ch ) { PUTC( 0 ); return (cnt); }

		flags = 0; dprec = 0; fpprec = 0; width = 0;
		prec = -1;
		sign = '\0';

rflag:		switch (*++fmt) {
		case ' ':
			/*
			 * ``If the space and + flags both appear, the space
			 * flag will be ignored.''
			 *	-- ANSI X3J11
			 */
			if (!sign)
				sign = ' ';
			goto rflag;
		case '#':
			flags |= ALT;
			goto rflag;
		case '*':
			/*
			 * ``A negative field width argument is taken as a
			 * - flag followed by a  positive field width.''
			 *	-- ANSI X3J11
			 * They don't exclude field widths read from args.
			 */
			if ((width = va_arg(argp, int)) >= 0)
				goto rflag;
			width = -width;
			/* FALLTHROUGH */
		case '-':
			flags |= LADJUST;
			goto rflag;
		case '+':
			sign = '+';
			goto rflag;
		case '.':
			if (*++fmt == '*')
				n = va_arg(argp, int);
			else {
				n = 0;
				while (isascii(*fmt) && isdigit(*fmt))
					n = 10 * n + todigit(*fmt++);
				--fmt;
			}
			prec = n < 0 ? -1 : n;
			goto rflag;
		case '0':
			/*
			 * ``Note that 0 is taken as a flag, not as the
			 * beginning of a field width.''
			 *	-- ANSI X3J11
			 */
			flags |= ZEROPAD;
			goto rflag;
		case '1': case '2': case '3': case '4':
		case '5': case '6': case '7': case '8': case '9':
			n = 0;
			do {
				n = 10 * n + todigit(*fmt++);
			} while (isascii(*fmt) && isdigit(*fmt));
			width = n;
			--fmt;
			goto rflag;
		case 'L':
			flags |= LONGDBL;
			goto rflag;
		case 'h':
			flags |= SHORTINT;
			goto rflag;
		case 'l':
			flags |= LONGINT;
			goto rflag;
		case 'c':
			*(t = buf) = va_arg(argp, int);
			size = 1;
			sign = '\0';
			goto pforw;
		case 'D':
			flags |= LONGINT;
			/*FALLTHROUGH*/
		case 'd':
		case 'i':
			ARG(int);
			if ((long)_ulong < 0) {
				_ulong = -_ulong;
				sign = '-';
			}
			base = 10;
			goto number;
//del//#if 0
//del//		case 'e':
//del//		case 'E':
//del//		case 'f':
//del//		case 'g':
//del//		case 'G':
//del//			_double = va_arg(argp, double);
//del//			/*
//del//			 * don't do unrealistic precision; just pad it with
//del//			 * zeroes later, so buffer size stays rational.
//del//			 */
//del//			if (prec > MAXFRACT) {
//del//				if (*fmt != 'g' && *fmt != 'G' || (flags&ALT))
//del//					fpprec = prec - MAXFRACT;
//del//				prec = MAXFRACT;
//del//			}
//del//			else if (prec == -1)
//del//			{
//del//				if (flags&LONGINT)
//del//					prec = DEFLPREC;
//del//				else
//del//					prec = DEFPREC;
//del//			}
//del//			/*
//del//			 * softsign avoids negative 0 if _double is < 0 and
//del//			 * no significant digits will be shown
//del//			 */
//del//			if (_double < 0) {
//del//				softsign = '-';
//del//				_double = -_double;
//del//			}
//del//			else
//del//				softsign = 0;
//del//			/*
//del//			 * cvt may have to round up past the "start" of the
//del//			 * buffer, i.e. ``intf("%.2f", (double)9.999);'';
//del//			 * if the first char isn't NULL, it did.
//del//			 */
//del//			*buf = NULL;
//del//			size = cvt(_double, prec, flags, &softsign, *fmt, buf,
//del//			    buf + sizeof(buf));
//del//			if (softsign && !nan)
//del//				sign = '-';
//del//			nan = 0;
//del//			t = *buf ? buf : buf + 1;
//del//			goto pforw;
//del//#endif
		case 'n':
			if (flags & LONGINT)
				*va_arg(argp, long *) = cnt;
			else if (flags & SHORTINT)
				*va_arg(argp, short *) = cnt;
			else
				*va_arg(argp, int *) = cnt;
			break;
		case 'O':
			flags |= LONGINT;
			/*FALLTHROUGH*/
		case 'o':
			ARG(unsigned);
			base = 8;
			goto nosign;
		case 'p':
			/*
			 * ``The argument shall be a pointer to void.  The
			 * value of the pointer is converted to a sequence
			 * of printable characters, in an implementation-
			 * defined manner.''
			 *	-- ANSI X3J11
			 */
			/* NOSTRICT */
			_ulong = (u_long)va_arg(argp, void *);
			base = 16;
			goto nosign;
		case 's':
			if (!(t = va_arg(argp, char *)))
				t = "(null)";
			if (prec >= 0) {
				/*
				 * can't use strlen; can only look for the
				 * NUL in the first `prec' characters, and
				 * strlen() will go further.
				 */
				char *p, *memchr();

				if ((p = memchr(t, 0, prec))!=0) {
					size = p - t;
					if (size > prec)
						size = prec;
				} else
					size = prec;
			} else
				size = strlen(t);
			sign = '\0';
			goto pforw;
		case 'U':
			flags |= LONGINT;
			/*FALLTHROUGH*/
		case 'u':
			ARG(unsigned);
			base = 10;
			goto nosign;
		case 'X':
			digs = "0123456789ABCDEF";
			/* FALLTHROUGH */
		case 'x':
			ARG(unsigned);
			base = 16;
			/* leading 0x/X only if non-zero */
			if (flags & ALT && _ulong != 0)
				flags |= HEXPREFIX;

			/* unsigned conversions */
nosign:			sign = '\0';
			/*
			 * ``... diouXx conversions ... if a precision is
			 * specified, the 0 flag will be ignored.''
			 *	-- ANSI X3J11
			 */
number:			if ((dprec = prec) >= 0)
				flags &= ~ZEROPAD;

			/*
			 * ``The result of converting a zero value with an
			 * explicit precision of zero is no characters.''
			 *	-- ANSI X3J11
			 */
			t = buf + BUF;
			if (_ulong != 0 || prec != 0) {
				do {
					*--t = digs[_ulong % base];
					_ulong /= base;
				} while (_ulong);
				digs = "0123456789abcdef";
				if (flags & ALT && base == 8 && *t != '0')
					*--t = '0'; /* octal leading 0 */
			}
			size = buf + BUF - t;

pforw:
			/*
			 * All reasonable formats wind up here.  At this point,
			 * `t' points to a string which (if not flags&LADJUST)
			 * should be padded out to `width' places.  If
			 * flags&ZEROPAD, it should first be prefixed by any
			 * sign or other prefix; otherwise, it should be blank
			 * padded before the prefix is emitted.  After any
			 * left-hand padding and prefixing, emit zeroes
			 * required by a decimal [diouxX] precision, then print
			 * the string proper, then emit zeroes required by any
			 * leftover floating precision; finally, if LADJUST,
			 * pad with blanks.
			 */

			/*
			 * compute actual size, so we know how much to pad
			 * fieldsz excludes decimal prec; realsz includes it
			 */
			fieldsz = size + fpprec;
			realsz = dprec > fieldsz ? dprec : fieldsz;
			if (sign)
				realsz++;
			if (flags & HEXPREFIX)
				realsz += 2;

			/* right-adjusting blank padding */
			if ((flags & (LADJUST|ZEROPAD)) == 0 && width)
				for (n = realsz; n < width; n++)
					PUTC(' ');
			/* prefix */
			if (sign)
				PUTC(sign);
			if (flags & HEXPREFIX) {
				PUTC('0');
				PUTC((char)*fmt);
			}
			/* right-adjusting zero padding */
			if ((flags & (LADJUST|ZEROPAD)) == ZEROPAD)
				for (n = realsz; n < width; n++)
					PUTC('0');
			/* leading zeroes from decimal precision */
			for (n = fieldsz; n < dprec; n++)
				PUTC('0');

			/* the string or number proper */
			n = size;
			while (--n >= 0) PUTC(*t++);
			/* trailing f.p. zeroes */
			while (--fpprec >= 0)
				PUTC('0');
			/* left-adjusting padding (always blank) */
			if (flags & LADJUST)
				for (n = realsz; n < width; n++)
					PUTC(' ');
			/* finally, adjust cnt */
			cnt += width > realsz ? width : realsz;
			break;
		case '\0':	/* "%?" prints ?, unless ? is NULL */
			PUTC( 0 );
			return (cnt);
		default:
			PUTC((char)*fmt);
			cnt++;
		}
	}
	/* NOTREACHED */
}


//del//#if 0
//del//
//del//#if 0
//del//#define	tochar(n)	((n) + '0')
//del//#else
//del//static char tochar(int n)
//del//{
//del//  if (n>=9) return '9';
//del//  if (n<=0) return '0';
//del//  return n+'0';
//del//}
//del//#endif
//del//
//del//
//del//static
//del//cvt(number, prec, flags, signp, fmtch, startp, endp)
//del//	double number;
//del//	register int prec;
//del//	int flags;
//del//	u_char fmtch;
//del//	char *signp, *startp, *endp;
//del//{
//del//	register char *p, *t;
//del//	register double fract;
//del//	int dotrim, expcnt, gformat;
//del//	double integer, tmp, modf();
//del//	char *exponent(), *round();
//del//
//del//#ifdef hp300
//del//	if (expcnt = isspecial(number, startp, signp))
//del//		return(expcnt);
//del//#endif
//del//#ifdef __GO32__
//del//	if (expcnt = isspecial(number, startp))
//del//		return(expcnt);
//del//#endif
//del//
//del//	dotrim = expcnt = gformat = 0;
//del//	fract = modf(number, &integer);
//del//
//del//	/* get an extra slot for rounding. */
//del//	t = ++startp;
//del//
//del//	/*
//del//	 * get integer portion of number; put into the end of the buffer; the
//del//	 * .01 is added for modf(356.0 / 10, &integer) returning .59999999...
//del//	 */
//del//	for (p = endp - 1; integer; ++expcnt) {
//del//		tmp = modf(integer / 10, &integer);
//del//		*p-- = tochar((int)((tmp + .01) * 10));
//del//	}
//del//	switch(fmtch) {
//del//	case 'f':
//del//		/* reverse integer into beginning of buffer */
//del//		if (expcnt)
//del//			for (; ++p < endp; *t++ = *p);
//del//		else
//del//			*t++ = '0';
//del//		/*
//del//		 * if precision required or alternate flag set, add in a
//del//		 * decimal point.
//del//		 */
//del//		if (prec || flags&ALT)
//del//			*t++ = decimal;
//del//		/* if requires more precision and some fraction left */
//del//		if (fract) {
//del//			if (prec)
//del//				do {
//del//					fract = modf(fract * 10, &tmp);
//del//					*t++ = tochar((int)tmp);
//del//				} while (--prec && fract);
//del//			if (fract)
//del//				startp = round(fract, (int *)NULL, startp,
//del//				    t - 1, (char)0, signp);
//del//		}
//del//		for (; prec--; *t++ = '0');
//del//		break;
//del//	case 'e':
//del//	case 'E':
//del//eformat:	if (expcnt) {
//del//			*t++ = *++p;
//del//			if (prec || flags&ALT)
//del//				*t++ = decimal;
//del//			/* if requires more precision and some integer left */
//del//			for (; prec && ++p < endp; --prec)
//del//				*t++ = *p;
//del//			/*
//del//			 * if done precision and more of the integer component,
//del//			 * round using it; adjust fract so we don't re-round
//del//			 * later.
//del//			 */
//del//			if (!prec && ++p < endp) {
//del//				fract = 0;
//del//				startp = round((double)0, &expcnt, startp,
//del//				    t - 1, *p, signp);
//del//			}
//del//			/* adjust expcnt for digit in front of decimal */
//del//			--expcnt;
//del//		}
//del//		/* until first fractional digit, decrement exponent */
//del//		else if (fract) {
//del//			/* adjust expcnt for digit in front of decimal */
//del//			for (expcnt = -1;; --expcnt) {
//del//				fract = modf(fract * 10, &tmp);
//del//				if (tmp)
//del//					break;
//del//			}
//del//			*t++ = tochar((int)tmp);
//del//			if (prec || flags&ALT)
//del//				*t++ = decimal;
//del//		}
//del//		else {
//del//			*t++ = '0';
//del//			if (prec || flags&ALT)
//del//				*t++ = decimal;
//del//		}
//del//		/* if requires more precision and some fraction left */
//del//		if (fract) {
//del//			if (prec)
//del//				do {
//del//					fract = modf(fract * 10, &tmp);
//del//					*t++ = tochar((int)tmp);
//del//				} while (--prec && fract);
//del//			if (fract)
//del//				startp = round(fract, &expcnt, startp,
//del//				    t - 1, (char)0, signp);
//del//		}
//del//		/* if requires more precision */
//del//		for (; prec--; *t++ = '0');
//del//
//del//		/* unless alternate flag, trim any g/G format trailing 0's */
//del//		if (gformat && !(flags&ALT)) {
//del//			while (t > startp && *--t == '0');
//del//			if (*t == decimal)
//del//				--t;
//del//			++t;
//del//		}
//del//		t = exponent(t, expcnt, fmtch);
//del//		break;
//del//	case 'g':
//del//	case 'G':
//del//		/* a precision of 0 is treated as a precision of 1. */
//del//		if (!prec)
//del//			++prec;
//del//		/*
//del//		 * ``The style used depends on the value converted; style e
//del//		 * will be used only if the exponent resulting from the
//del//		 * conversion is less than -4 or greater than the precision.''
//del//		 *	-- ANSI X3J11
//del//		 */
//del//		if (expcnt > prec || !expcnt && fract && fract < .0001) {
//del//			/*
//del//			 * g/G format counts "significant digits, not digits of
//del//			 * precision; for the e/E format, this just causes an
//del//			 * off-by-one problem, i.e. g/G considers the digit
//del//			 * before the decimal point significant and e/E doesn't
//del//			 * count it as precision.
//del//			 */
//del//			--prec;
//del//			fmtch -= 2;		/* G->E, g->e */
//del//			gformat = 1;
//del//			goto eformat;
//del//		}
//del//		/*
//del//		 * reverse integer into beginning of buffer,
//del//		 * note, decrement precision
//del//		 */
//del//		if (expcnt)
//del//			for (; ++p < endp; *t++ = *p, --prec);
//del//		else
//del//			*t++ = '0';
//del//		/*
//del//		 * if precision required or alternate flag set, add in a
//del//		 * decimal point.  If no digits yet, add in leading 0.
//del//		 */
//del//		if (prec || flags&ALT) {
//del//			dotrim = 1;
//del//			*t++ = decimal;
//del//		}
//del//		else
//del//			dotrim = 0;
//del//		/* if requires more precision and some fraction left */
//del//		while (prec && fract) {
//del//			fract = modf(fract * 10, &tmp);
//del//			*t++ = tochar((int)tmp);
//del//			prec--;
//del//		}
//del//		if (fract)
//del//			startp = round(fract, (int *)NULL, startp, t - 1,
//del//					(char)0, signp);
//del//		/* alternate format, adds 0's for precision, else trim 0's */
//del//		if (flags&ALT)
//del//			for (; prec--; *t++ = '0');
//del//		else if (dotrim) {
//del//			while (t > startp && *--t == '0');
//del//			if (*t != decimal)
//del//				++t;
//del//		}
//del//	}
//del//	return(t - startp);
//del//}
//del//
//del//static char *
//del//round(fract, exp, start, end, ch, signp)
//del//	double fract;
//del//	int *exp;
//del//	register char *start, *end;
//del//	char ch, *signp;
//del//{
//del//	double tmp;
//del//	double modf();
//del//
//del//	if (fract)
//del//		(void)modf(fract * 10, &tmp);
//del//	else
//del//		tmp = todigit(ch);
//del//	if (tmp > 4)
//del//		for (;; --end) {
//del//			if (*end == decimal)
//del//				--end;
//del//			if (++*end <= '9')
//del//				break;
//del//			*end = '0';
//del//			if (end == start) {
//del//				if (exp) {	/* e/E; increment exponent */
//del//					*end = '1';
//del//					++*exp;
//del//				}
//del//				else {		/* f; add extra digit */
//del//					*--end = '1';
//del//					--start;
//del//				}
//del//				break;
//del//			}
//del//		}
//del//	/* ``"%.3f", (double)-0.0004'' gives you a negative 0. */
//del//	else if (*signp == '-')
//del//		for (;; --end) {
//del//			if (*end == decimal)
//del//				--end;
//del//			if (*end != '0')
//del//				break;
//del//			if (end == start)
//del//				*signp = 0;
//del//		}
//del//	return(start);
//del//}
//del//
//del//static char *
//del//exponent(p, exp, fmtch)
//del//	register char *p;
//del//	register int exp;
//del//	u_char fmtch;
//del//{
//del//	register char *t;
//del//	char expbuf[MAXEXP];
//del//
//del//	*p++ = fmtch;
//del//	if (exp < 0) {
//del//		exp = -exp;
//del//		*p++ = '-';
//del//	}
//del//	else
//del//		*p++ = '+';
//del//	t = expbuf + MAXEXP;
//del//	if (exp > 9) {
//del//		do {
//del//			*--t = tochar(exp % 10);
//del//		} while ((exp /= 10) > 9);
//del//		*--t = tochar(exp);
//del//		for (; t < expbuf + MAXEXP; *p++ = *t++);
//del//	}
//del//	else {
//del//		*p++ = '0';
//del//		*p++ = tochar(exp);
//del//	}
//del//	return(p);
//del//}
//del//
//del//#ifdef hp300
//del//isspecial(d, bufp, signp)
//del//	double d;
//del//	char *bufp, *signp;
//del//{
//del//	register struct IEEEdp {
//del//		unsigned sign:1;
//del//		unsigned exp:11;
//del//		unsigned manh:20;
//del//		unsigned manl:32;
//del//	} *ip = (struct IEEEdp *)&d;
//del//
//del//	if (ip->exp != 0x7ff)
//del//		return(0);
//del//	if (ip->manh || ip->manl)
//del//		(void)strcpy(bufp, "NaN");
//del//	else
//del//		(void)strcpy(bufp, "Inf");
//del//	return(3);
//del//}
//del//#endif
//del//
//del//#ifdef __GO32__
//del//static int isspecial(d, bufp)
//del//	double d;
//del//	char *bufp;
//del//{
//del//    	register struct IEEEdp {
//del//        	unsigned manl:32;
//del//        	unsigned manh:20;
//del//        	unsigned exp:11;
//del//        	unsigned sign:1;
//del//	} *ip = (struct IEEEdp *)&d;
//del//
//del//	if (ip->exp != 0x7ff)
//del//		return(0);
//del//	if (ip->manh || ip->manl)
//del//    	{
//del//		strcpy(bufp, "NaN");
//del//        	nan = 1; /* kludge: we don't need the sign,  it's not nice
//del//		            but it should work */
//del//    	}
//del//	else
//del//		(void)strcpy(bufp, "Inf");
//del//    	return(3);
//del//}
//del//#endif
//del//
//del//#endif //0


//del////!///// Piece Kernel Service API Reference
//del////! 
//del////! ■ pcevsprintf
//del////! ■ pcesprintf
//del////!
//del////! バッファに文字列を出力します(書式指定)
//del////!
//del////! int pcevsprintf(
//del////!		char *outp,			// 出力バッファ
//del////!		const char *fmt0,	// 書式文字列
//del////!		va_list argp		// 可変引数
//del////!		);
//del////!		
//del////!
//del////! int pcesprintf(
//del////!		char *outp,			// 出力バッファ
//del////!		const char *fmt,	// 書式文字列
//del////!		...					// 可変引数
//del////!		);
//del////!
//del////! 戻り値：出力したバイト数
//del////!
//del////! sprintf(), vsprintf() の組み込み簡易バージョンです。
//del////! 浮動小数点は使えません。(%f,%e,%g等)
//del////!
//del////! #define NOPCESPRINTF
//del////! が指定せずに piece.h をインクルードした場合、sprintf,vsprintf は
//del////!	これが使われます。
//del////!
//del//
//del//int pcevsprintf( char *outp, const char *fmt0, va_list argp )
//del//{
//del//	OUTBF b;
//del//	b.outp = outp;
//del//	b.endp = (char *)-1;
//del//	return doprnt( &b, fmt0, argp );
//del//}
//del//
//del//int pcesprintf( char *outp, const char *fmt, ... )
//del//{
//del//	OUTBF b;
//del//	b.outp = outp;
//del//	b.endp = (char *)-1;
//del//	return doprnt( &b, fmt, (va_list)((&fmt)+1) );
//del//}

//!///// Piece Kernel Service API Reference
//! 
//! ■ pceFontPrintf
//! 
//! 文字列を仮想画面に書き込みます。（書式指定）
//!
//! int pceFontPrintf(
//!			const char *fmt,	// 書式文字列
//!			...					// 可変引数
//!			);
//!
//! 戻り値：出力したバイト数
//!
//! pceFontPutStr() の printf タイプです。
//! 内部で pceFontPutStr() を呼び出します。
//! 表示位置は pceFontPutStr() に従います。
//! 浮動小数点は使えません。(%f,%e,%g等)
//!

int pceFontPutStr( const char *p );

static void OutFont( OUTBF *pob )
{
	int a;
	*pob->outp = 0;
	a = pceFontPutStr( pob->topp );
	pob->outp = pob->topp;
	if ( a ) *pob->outp++ = a;
}


int pceFontPrintf( const char *fmt, ... )
{
	OUTBF b;
	char buff[31+1];
	int c;
	b.topp =
	b.outp = buff;
	b.endp = buff+sizeof(buff)-1;
	b.flush = OutFont;
	c = doprnt( &b, fmt, (va_list)((&fmt)+1) );
	OutFont( &b );
	return c;
}




